import { EventEmitter, OnInit, QueryList, TemplateRef } from '@angular/core';
import { ActivatedRoute, Router } from "@angular/router";
import { Location } from '@angular/common';
import { FilteredTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { TableFilter } from "@yukawa/chain-base-angular-domain";
import { RouteDesc, TableLayoutInput } from "../types";
import * as i0 from "@angular/core";
export declare class TableRowColumnDirective {
    templateRef: TemplateRef<any>;
    rowColumn: string;
    constructor(templateRef: TemplateRef<any>);
    static ɵfac: i0.ɵɵFactoryDeclaration<TableRowColumnDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TableRowColumnDirective, "ng-template[rowColumn]", never, { "rowColumn": "rowColumn"; }, {}, never, never, false>;
}
export declare class TableContentComponent implements OnInit {
    private router;
    private activatedRoute;
    private location;
    _tableLayoutInput: TableLayoutInput;
    dataSource: FilteredTableSource<any, any>;
    set tableLayoutInput(tl: TableLayoutInput);
    get tableLayoutInput(): TableLayoutInput;
    rowColumnDirectives: QueryList<TableRowColumnDirective>;
    rowColumnTemplates: Map<string, TableRowColumnDirective>;
    hasToolbar: boolean;
    hasSearch: boolean;
    hasAddButton: boolean;
    hasBackButton: boolean;
    hasPaginator: boolean;
    tableRowClick: EventEmitter<any>;
    addRoute: RouteDesc;
    backRoute: RouteDesc;
    private paginator;
    private sort;
    set matSort(ms: MatSort);
    set matPaginator(ms: MatPaginator);
    displayedColumns: String[];
    columnNames: String[];
    constructor(router: Router, activatedRoute: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    getPageSizeOptions(): number[];
    getDefaultPageSize(): number;
    add(): void;
    back(): void;
    onRowClick(row: any): void;
    reload(filter: TableFilter | any): boolean;
    navigateBack(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableContentComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableContentComponent, "base-table-content", never, { "tableLayoutInput": "tableLayoutInput"; "hasToolbar": "hasToolbar"; "hasSearch": "hasSearch"; "hasAddButton": "hasAddButton"; "hasBackButton": "hasBackButton"; "hasPaginator": "hasPaginator"; }, { "tableRowClick": "tableRowClick"; }, ["rowColumnDirectives"], ["[controls]"], false>;
}
